#include <stdarg.h>

#include "list.h"
#include "misc.h"


List*
addToList(List* list, ...)
{
	void* object;
	va_list ap;

	va_start(ap, list);
	while ((object = va_arg(ap, void*))) {
		List* element = MALLOC(sizeof(List));
		if (!element) break;
		element->object = object;
		element->next = list;
		list = element;
	}
	va_end(ap);
	return list;
}

List*
freeList(List* list)
{
	List* element = list;
	while(element) {
		List* next = element->next;
		FREE(element->object);
		FREE(element);
		element = next;
	}
	return NULL;
}

#if 0
int
handleList(List* list, *((int)handle(void*)))
{
	List* element = list;
	int result = 0;
	while(element) {
		result += handle(element->object);
		element = element->next;
	}
	return result;
}
#endif

