/* $Id: misc.h,v 1.7 2002/10/24 22:41:04 maxim Exp $
 */

#ifndef MISC_H
#define MISC_H

#include <time.h>

#define DEBUGLOG 0

int fdSize(int fd);
int fileSize(char* filename);
int fileSizeKb(char* filename);
time_t fileTime(char* filename);
char exists(char* filename);
char makedir(char* dir);
char writePidFile(char* name, char daemon);
char* readFile(char* fileName, int* size);


int addCount(char* file, char doFlush);


enum {
	LOCAL_TIME,
	LOCAL_DATE,
	TODAY_TIME,
	SQL_DATE,
	SQL_TIME,
	HTTP_TIME,
	COOKIE_TIME
};


//#define TM_DAY(TM) (((TM.tm_year-100) * 366) + TM.tm_yday)
//#define TM_DAY(TM) (((TM.tm_year-100) << 9) + (TM.tm_mon << 5) + TM.tm_mday)
//#define TM_DAY(TM) ((TM.tm_year-100)*10000 + (TM.tm_mon+1)*100 + TM.tm_mday)
char* time2str(time_t t, char type);
void getTime();
short getDay(struct tm* tm);
struct tm* getDate(short day);
unsigned biRound(unsigned value, unsigned n);
short countBits(int v);

char removeDir(char* name);

int initServerSocket(int domain, char* address, int port);
int doConnect(int domain, char* address, int port, int timeout);
int readMessage(int fd, char* buffer, int maxSize, int timeout);
int writeMessage(int fd, char* buffer, int size, int timeout);




#define isleap(y) ((((y) % 4) == 0 && ((y) % 100) != 0) || ((y) % 400) == 0)

#define MALLOC(size) malloc_wrapper(size, __FILE__, __LINE__)
#define REALLOC(ptr, size) realloc_wrapper(ptr, size, __FILE__, __LINE__)
#define FREE(ptr) free_wrapper(ptr, __FILE__, __LINE__)
void* malloc_wrapper(size_t size, char* file, int line);
void* realloc_wrapper(void* ptr, size_t size, char* file, int line);
void* free_wrapper(void* ptr, char* file, int line);

#define min(a,b) ((a) < (b) ? (a) : (b))
#define max(a,b) ((a) > (b) ? (a) : (b))

#if 0
#define QQ() fix_position(__FILE__, __LINE__)
#else
#define QQ()
#endif
void fix_position(char* file, int line);
extern char* lastPositionFile;
extern int lastPositionLine;


#define DEBUG		  0
#define MESSAGE		  1
#define ERROR		  2
#define ACTION		  3
#define ACCESS		  4
#define CLOSE_LOGS	  7
#define TYPE_MASK	  7

#define SYS_MASK	  (1 << 4)
#define MY			  (0 << 4)
#define SYS			  (1 << 4)

#define message(flags, fmt, X...) message__(__FILE__, __LINE__, flags, fmt, ##X)

#if DEBUGLOG
#define debug(fmt, X...) message(DEBUG, fmt, ##X)
#else
#define debug(fmt, X...)
#endif

char message__(char* file, int pos, int flags, char* fmt, ...);


#define SNPRINTF(string, length, fmt, X...) snprintf__(__FILE__, __LINE__, string, length, fmt, ##X)
int snprintf__(char* file, int pos, char* string, int length, char* fmt, ...);

extern time_t now;
extern struct tm now_tm;
extern short now_day;
extern char now_str[];

extern int Debug;
extern int myPID;
extern char* skin;
extern char* progName;
extern char* logName[TYPE_MASK+1];

#endif

