#ifndef PAIRS_H
#define PAIRS_H

typedef struct Pair_struct Pair;
typedef struct Pairs_struct Pairs;

struct Pair_struct {
	char* name;
	void* value;
	Pair* next;
};

struct Pairs_struct {
	Pair** pairs;
	int size;
	void* (*freeFunction)(void*);

	int count;
	Pair* last;
	int lastHash;
};



Pairs* newPairs(int size, void* (*freeFunction)(void*));
Pairs* freePairs(Pairs* pairs);
void setPair(Pairs* pairs, char* name, void* value);
void* getPair(Pairs* pairs, char* name);
void startListPairs(Pairs* pairs);
Pair* nextPair(Pairs* pairs);

#endif

