/* $Id: core.c,v 1.10 2002/05/15 10:28:57 maxim Exp $
 */

#include <string.h>
#include <stdio.h>

#include "common/misc.h"
#include "httpd.h"


#ifdef _3DNEWS_ADDON
enum {
	FILTER_3D_SEARCH = 1,
	FILTER_3D_PREFIX,
	FILTER_3D_PREFIX_SELECT,
	FILTER_3D_PREFIX_1,
	FILTER_3D_PREFIX_2,
};


void
filter3DNews(Request* r, char flush)
{
	char* c;
	char* end;
	const char* prefix	= "ftp://f";
	const char* prefix1 = "_______iles.3dnews.ru";
	const char* prefix2 = "_______tp.3dnews.ru";
	const char* rewrited1 = "/files";
	const char* rewrited2 = "/old_files";

	if (flush) {
		r->filtered += r->filter.pos + (r->filter.quote?1:0);
		return;
	}

	c = r->content + r->filtered + r->filter.pos + (r->filter.quote?1:0) - r->offset;
	end = r->content + r->received - r->offset;

	for (; c < end; c++) {
		switch (r->filter.state) {
		case FILTER_3D_SEARCH:
			while (TRUE) {
				if (*c == '"' || *c == '\'') {
					r->filter.quote = *c;
					r->filter.pos = 0;
					break;
				}
				if (*c == *prefix) {
					r->filter.quote = 0;
					r->filter.pos = 1;
					break;
				}
				r->filtered++;
				if (++c == end) return;
			}
			r->filter.state = FILTER_3D_PREFIX;
			break;

		case FILTER_3D_PREFIX:
			while (*c == prefix[r->filter.pos++]) {
				if (!prefix[r->filter.pos]) {
					r->filter.state = FILTER_3D_PREFIX_SELECT;
					break;
				}
				if (++c == end) return;
			}
			if (!prefix[r->filter.pos]) break;

			r->filtered += r->filter.pos + (r->filter.quote?1:0);
			r->filter.state = FILTER_3D_SEARCH;
			r->filter.pos = 0;
			r->filter.quote = 0;
			break;

		case FILTER_3D_PREFIX_SELECT:
			if (*c == prefix1[r->filter.pos]) {
				r->filter.state = FILTER_3D_PREFIX_1;
				r->filter.pos++;
			} else if (*c == prefix2[r->filter.pos]) {
				r->filter.state = FILTER_3D_PREFIX_2;
				r->filter.pos++;
			} else {
				r->filtered += r->filter.pos + 1 + (r->filter.quote?1:0);
				r->filter.state = FILTER_3D_SEARCH;
				r->filter.pos = 0;
				r->filter.quote = 0;
			}
			break;

		case FILTER_3D_PREFIX_1:
			while (*c == prefix1[r->filter.pos++]) {
				if (!prefix1[r->filter.pos]) {
					char* dest = r->content + r->filtered - r->offset;
					memset(dest, ' ', strlen(prefix1) - strlen(rewrited1));
					dest += strlen(prefix1) - strlen(rewrited1);
					if (r->filter.quote) *dest++ = r->filter.quote;
					memcpy(dest, rewrited1, strlen(rewrited1));
					break;
				}
				if (++c == end) return;
			}
			r->filtered += r->filter.pos + (r->filter.quote?1:0);
			r->filter.state = FILTER_3D_SEARCH;
			r->filter.pos = 0;
			r->filter.quote = 0;
			break;

		case FILTER_3D_PREFIX_2:
			while (*c == prefix2[r->filter.pos++]) {
				if (!prefix2[r->filter.pos]) {
					char* dest = r->content + r->filtered - r->offset;
					memset(dest, ' ', strlen(prefix2) - strlen(rewrited2));
					dest += strlen(prefix2) - strlen(rewrited2);
					if (r->filter.quote) *dest++ = r->filter.quote;
					memcpy(dest, rewrited2, strlen(rewrited2));
					break;
				}
				if (++c == end) return;
			}
			r->filtered += r->filter.pos + (r->filter.quote?1:0);
			r->filter.state = FILTER_3D_SEARCH;
			r->filter.pos = 0;
			r->filter.quote = 0;
			break;
		}
	}
}

void
filter3DNews_old(Request* r, char flush)
{
	char* c;
	char* end;
	const char* prefix = "ftp://files.3dnews.ru";
	const char* rewrited = "/files";

	if (flush) {
		r->filtered += r->filter.pos + (r->filter.quote?1:0);
		return;
	}

	c = r->content + r->filtered + r->filter.pos + (r->filter.quote?1:0) - r->offset;
	end = r->content + r->received - r->offset;

	for (; c < end; c++) {
		switch (r->filter.state) {
		case FILTER_3D_SEARCH:
			while (TRUE) {
				if (*c == '"' || *c == '\'') {
					r->filter.quote = *c;
					r->filter.pos = 0;
					break;
				}
				if (*c == *prefix) {
					r->filter.quote = 0;
					r->filter.pos = 1;
					break;
				}
				r->filtered++;
				if (++c == end) return;
			}
			r->filter.state = FILTER_3D_PREFIX;
			break;

		case FILTER_3D_PREFIX:
			while (*c == prefix[r->filter.pos++]) {
				if (!prefix[r->filter.pos]) {
					char* dest = r->content + r->filtered - r->offset;
					memset(dest, ' ', strlen(prefix) - strlen(rewrited));
					dest += strlen(prefix) - strlen(rewrited);
					if (r->filter.quote) *dest++ = r->filter.quote;
					memcpy(dest, rewrited, strlen(rewrited));
					break;
				}
				if (++c == end) return;
			}
			r->filtered += r->filter.pos + (r->filter.quote?1:0);
			r->filter.state = FILTER_3D_SEARCH;
			r->filter.pos = 0;
			r->filter.quote = 0;
			break;
		}
	}
}
#endif



enum {
	STRIP_META_SEARCH = 1,
	STRIP_META_PREFIX,
};


void
filterStripMeta(Request* r, char flush)
{
	char* c;
	char* end;
	const char* prefix = "<meta";

	if (flush) {
		r->filtered += r->filter.pos;
		return;
	}

	c = r->content + r->filtered + r->filter.pos - r->offset;
	end = r->content + r->received - r->offset;

	for (; c < end; c++) {
		switch (r->filter.state) {
		case STRIP_META_SEARCH:
			while (*c != *prefix) {
				r->filtered++;
				if (++c == end) return;
			}
			r->filter.pos = 1;
			r->filter.state = STRIP_META_PREFIX;
			break;

		case STRIP_META_PREFIX:
			while (*c == prefix[r->filter.pos++]) {
				if (!prefix[r->filter.pos]) {
					r->content[r->filtered - r->offset + 1] = '!';
					break;
				}
				if (++c == end) return;
			}
			r->filtered += r->filter.pos;
			r->filter.state = STRIP_META_SEARCH;
			r->filter.pos = 0;
			break;
		}
	}
}

